include AddinTester.inc

.code

DllEntry proc hInst:HINSTANCE, reason:DWORD, reserved1:DWORD
	mov eax, hInst
	mov hInstance, eax
	mov eax, TRUE
	ret
DllEntry Endp

InstallDll proc uses ebx hWin:DWORD, fOpt:DWORD
	mov	ebx,hWin

	;Get pointer to handles struct
	invoke SendMessage,ebx,AIM_GETHANDLES,0,0;	
	mov	lpHandles,eax
	
	;Get pointer to proc struct
	invoke SendMessage,ebx,AIM_GETPROCS,0,0
	mov	lpProc,eax

	;Get pointer to data struct
	invoke SendMessage,ebx,AIM_GETDATA,0,0	
	mov	lpData,eax

	; If Option (fOpt) = 0 then exit
	mov eax,fOpt
	mov fOption,eax
	test eax,eax
	je @exit
	
	; Allocate a new menu id
	invoke SendMessage,ebx,AIM_GETMENUID,0,0
	mov IDAddIn,eax

	;toolbar button will have the same id as our menuitem
	mov mytbbutton.idCommand,eax 
	call AddMenu

	mov ebx,[lpHandles] 
	mov ebx,(ADDINHANDLES ptr [ebx]).hToolBar 
	invoke SendMessage,ebx,TB_GETIMAGELIST,0,0 
	push eax 
	
	invoke LoadBitmap,hInstance,IDR_ADDINTESTER
	pop edx 
	push eax 
	invoke ImageList_AddMasked,edx,eax,808080h 
	mov mytbbutton.iBitmap,eax 
	pop eax 
	invoke DeleteObject,eax 
	invoke SendMessage,ebx,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,0 
	invoke SendMessage,ebx,TB_INSERTBUTTON,-1,offset mytbbutton 

	; Messages to hook into
	mov	eax, RAM_COMMAND OR RAM_CLOSE OR RAM_MENUREBUILD OR RAM_TBRTOOLTIP \
			OR RAM_PROJECTOPENED OR RAM_PROJECTCLOSE

@exit:
	; ECX and EDX must be null before we return
	xor ecx, ecx
	xor edx, edx
	ret 

InstallDll Endp

GetOptions proc
	mov eax,offset AddinOpt
	ret
GetOptions endp

DllProc proc hWin:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL buffer[512]:byte
	LOCAL tmp[256]:byte
	LOCAL fd:WIN32_FIND_DATA
	
    ; This proc handles messages sent from RadASM to our dll
	; Return TRUE to prevent RadASM and other DLL's from
	
	mov	eax, uMsg
	.if eax == AIM_COMMAND
		mov eax,wParam
		movzx edx,ax
		shr eax, 16
		.IF edx == IDAddIn && eax == BN_CLICKED
			mov edx,lpData
			mov edx,(ADDINDATA ptr [edx]).lpAddIn ;c:\radasm\addin
			invoke lstrcpy,addr buffer,edx ;buffer = 'c:\radasm\addin'
			invoke lstrcat,addr buffer,offset szAddinTester ;'c:\radasm\addin' + '\AddinTester.exe '
			invoke lstrcat,addr buffer,offset szCitSign ;'c:\radasm\addin\AddinTester.exe ' + '"'
			mov edx,lpData
			mov edx,(ADDINDATA ptr [edx]).lpProject
			invoke lstrcpy,addr tmp,edx
			lea edx,tmp
			push edx
			invoke lstrlen,edx
			pop edx
			mov ebx,edx
			add ebx,eax
			
			mov byte ptr [ebx - 1],"l"
			mov byte ptr [ebx - 2],"l"
			mov byte ptr [ebx - 3],"d"
			push edx
			
			invoke FindFirstFile,edx,addr fd
			.if eax==INVALID_HANDLE_VALUE
				pop edx
				invoke MessageBox,0,offset szNotAnAddin,offset szWarning,MB_OK or MB_ICONWARNING
			.else
				pop edx
				invoke lstrcat,addr buffer,edx
				invoke lstrcat,addr buffer,offset szCitSign
				invoke WinExec,addr buffer,SW_SHOWNORMAL
			.endif
			mov eax,TRUE
			ret

		.ENDIF

	.ELSEIF eax==AIM_CLOSE
		mov edx,lpHandles
		invoke DeleteMenu,[edx].ADDINHANDLES.hMenu,IDAddIn,MF_BYCOMMAND
		mov edx,lpHandles
		invoke SendMessage,[edx].ADDINHANDLES.hToolBar,TB_COMMANDTOINDEX,IDAddIn,0
		mov edx,lpHandles
		invoke SendMessage,[edx].ADDINHANDLES.hToolBar,TB_DELETEBUTTON,eax,0
		
	.ELSEIF eax==AIM_MENUREBUILD
		call AddMenu
		
	.ELSEIF eax==AIM_TBRTOOLTIP
		mov	eax,wParam
		.IF eax==IDAddIn
			mov eax,offset szAddinTestToolTip
			ret
		.ENDIF
	.ELSEIF eax==AIM_PROJECTCLOSE
		;
	.ELSEIF eax==AIM_PROJECTOPENED
		;
	.endif

	mov eax,FALSE
	ret
DllProc Endp

AddMenu proc
	LOCAL nMnu:DWORD
	LOCAL hMnu:DWORD

	.if IDAddIn
		mov	nMnu,6
		;Adjust topmost popup if maximized
		mov	eax,[lpData]
		mov	eax,(ADDINDATA ptr [eax]).fMaximized
		.if eax
			inc	nMnu
		.endif

		;Get handle of menu
		mov	eax,[lpHandles]
		mov	eax,(ADDINHANDLES ptr [eax]).hMenu

		;Get handle of Tools popup
		invoke GetSubMenu,eax,nMnu		;Tools menu
		mov	hMnu,eax

		;Add our menuitem
		invoke AppendMenu,hMnu,MF_STRING,IDAddIn,offset szAddinTestToolTip
;		invoke EnableMenuItem,hMnu,IDAddIn,MF_BYCOMMAND or MF_GRAYED
    .endif
	ret
AddMenu endp

End DllEntry
